/*
 *  ConfigDSN.c
 *
 *  $Id: main.c,v 1.1 1999/09/30 15:00:41 source Exp $
 *
 *  Login test program
 *
 *  The iODBC driver manager.
 *  
 *  Copyright (C) 1999 by OpenLink Software <iodbc@openlinksw.com>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <config.h>
#include <iodbcinst.h>
#include <stdio.h>

#define ATTRS	"DSN=Sample DSN\0Description=Just a sample DSN\0Address=localhost:1111\0UID=dba\0\0"
#define ATTRS1 "DSN=Sample DSN\0Address=localhost:1111\0UID=dba\0\0"
#define ATTRS2 "DSN=Sample DSN1\0Address=localhost:1111\0UID=dba\0\0"

int
main (int argc, char *argv[])
{
	BOOL retcode; DWORD errorcode;
	char errormsg[SQL_MAX_MESSAGE_LENGTH];
	char outpath[1024]={0};
	WORD len; int i;
	FILE *fp,*fp1;
	char ch,ch1;

	if(argc<2) return -1;

#ifndef _BE
	setenv("ODBCINI","./odbc.ini",TRUE);
	unlink("./odbc.ini");
	setenv("ODBCINSTINI","./odbcinst.ini",TRUE);
	unlink("./odbcinst.ini");
#endif

	printf("Test ConfigDSN with (NULL, ODBC_REMOVE_DSN+1, NULL, NULL)\n\r");
	retcode = ConfigDSN(NULL, ODBC_REMOVE_DSN+1, NULL, NULL);
	switch(retcode) {
		case FALSE:
			for(i=1 ; i<=8 ; i++) {
				switch( SQLInstallerError(i, &errorcode, errormsg, sizeof(errormsg), &len) ) {
					case SQL_NO_DATA:
						if(i==1) { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
						else break;
					case SQL_ERROR: printf("\tFAILED on SQLInstallerError\n\r"); return -1;
					case SQL_SUCCESS_WITH_INFO:
						if(i==1 && errorcode==ODBC_ERROR_INVALID_REQUEST_TYPE)
							{ printf("\tPASSED with a truncated string\n\r"); break; }
						else { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
					case SQL_SUCCESS:
						if(i==1 && errorcode==ODBC_ERROR_INVALID_REQUEST_TYPE)
							{ printf("\tPASSED\n\r"); break; }
						else { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
					default: printf("\tFAILED on SQLInstallerError\n\r"); return -1;
				};
			}
			break;
		case TRUE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDSN with (NULL, ODBC_REMOVE_DSN, NULL, NULL)\n\r");
	retcode = ConfigDSN(NULL, ODBC_REMOVE_DSN, NULL, NULL);
	switch(retcode) {
		case FALSE:
			for(i=2 ; i<=8 ; i++) {
				switch( SQLInstallerError(i, &errorcode, errormsg, sizeof(errormsg), &len) ) {
					case SQL_NO_DATA:
						if(i==2) { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
						else break;
					case SQL_ERROR: printf("\tFAILED on SQLInstallerError\n\r"); return -1;
					case SQL_SUCCESS_WITH_INFO:
						if(i==2 && errorcode==ODBC_ERROR_INVALID_NAME)
							{ printf("\tPASSED with a truncated string\n\r"); break; }
						else { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
					case SQL_SUCCESS:
						if(i==2 && errorcode==ODBC_ERROR_INVALID_NAME)
							{ printf("\tPASSED\n\r"); break; }
						else { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
					default: printf("\tFAILED on SQLInstallerError\n\r"); return -1;
				};
			}
			break;
		case TRUE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDSN with (NULL, ODBC_REMOVE_DSN, argv[1], NULL)\n\r");
	retcode = ConfigDSN(NULL, ODBC_REMOVE_DSN, argv[1], NULL);
	switch(retcode) {
		case FALSE:
			for(i=3 ; i<=8 ; i++) {
				switch( SQLInstallerError(i, &errorcode, errormsg, sizeof(errormsg), &len) ) {
					case SQL_NO_DATA:
						if(i==3) { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
						else break;
					case SQL_ERROR: printf("\tFAILED on SQLInstallerError\n\r"); return -1;
					case SQL_SUCCESS_WITH_INFO:
						if(i==3 && errorcode==ODBC_ERROR_INVALID_KEYWORD_VALUE)
							{ printf("\tPASSED with a truncated string\n\r"); break; }
						else { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
					case SQL_SUCCESS:
						if(i==3 && errorcode==ODBC_ERROR_INVALID_KEYWORD_VALUE)
							{ printf("\tPASSED\n\r"); break; }
						else { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
					default: printf("\tFAILED on SQLInstallerError\n\r"); return -1;
				};
			}
			break;
		case TRUE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDSN with (NULL, ODBC_ADD_DSN, argv[1], ATTRS)\n\r");
	retcode = ConfigDSN(NULL, ODBC_ADD_DSN, argv[1], ATTRS);
	switch(retcode) {
		case TRUE:
			fp = fopen("results/odbc.ini.1","rt");
			if(!fp) { printf("\tFAILED\n\r"); return -1; }
			fp1 = fopen("odbc.ini","rt");
			if(!fp1) { printf("\tFAILED\n\r"); return -1; }
			while(TRUE) {
				if(fread(&ch, sizeof(char), 1, fp)!=sizeof(char) || fread(&ch1, sizeof(char), 1, fp1)!=sizeof(char))
				{
					fread(&ch1, sizeof(char), 1, fp1);
					if(!(feof(fp) && feof(fp1))) { printf("\tFAILED\n\r"); return -1; }
					break;
				}
				if(ch != ch1) { printf("\tFAILED\n\r"); return -1; }
			}
			fclose(fp); fclose(fp1);

			printf("\tPASSED\n\r");
			break;
		case FALSE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDSN with (NULL, ODBC_ADD_DSN, argv[1], ATTRS1)\n\r");
	retcode = ConfigDSN(NULL, ODBC_ADD_DSN, argv[1], ATTRS1);
	switch(retcode) {
		case TRUE:
			fp = fopen("results/odbc.ini.5","rt");
			if(!fp) { printf("\tFAILED\n\r"); return -1; }
			fp1 = fopen("odbc.ini","rt");
			if(!fp1) { printf("\tFAILED\n\r"); return -1; }
			while(TRUE) {
				if(fread(&ch, sizeof(char), 1, fp)!=sizeof(char) || fread(&ch1, sizeof(char), 1, fp1)!=sizeof(char))
				{
					fread(&ch1, sizeof(char), 1, fp1);
					if(!(feof(fp) && feof(fp1))) { printf("\tFAILED\n\r"); return -1; }
					break;
				}
				if(ch != ch1) { printf("\tFAILED\n\r"); return -1; }
			}
			fclose(fp); fclose(fp1);

			printf("\tPASSED\n\r");
			break;
		case FALSE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDSN with (NULL, ODBC_ADD_DSN, argv[1], ATTRS)\n\r");
	retcode = ConfigDSN(NULL, ODBC_ADD_DSN, argv[1], ATTRS);
	switch(retcode) {
		case TRUE:
			fp = fopen("results/odbc.ini.1","rt");
			if(!fp) { printf("\tFAILED\n\r"); return -1; }
			fp1 = fopen("odbc.ini","rt");
			if(!fp1) { printf("\tFAILED\n\r"); return -1; }
			while(TRUE) {
				if(fread(&ch, sizeof(char), 1, fp)!=sizeof(char) || fread(&ch1, sizeof(char), 1, fp1)!=sizeof(char))
				{
					fread(&ch1, sizeof(char), 1, fp1);
					if(!(feof(fp) && feof(fp1))) { printf("\tFAILED\n\r"); return -1; }
					break;
				}
				if(ch != ch1) { printf("\tFAILED\n\r"); return -1; }
			}
			fclose(fp); fclose(fp1);

			printf("\tPASSED\n\r");
			break;
		case FALSE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDSN with (NULL, ODBC_CONFIGURE_DSN, argv[1], ATTRS1)\n\r");
	retcode = ConfigDSN(NULL, ODBC_CONFIG_DSN, argv[1], ATTRS1);
	switch(retcode) {
		case TRUE:
			fp = fopen("results/odbc.ini.1","rt");
			if(!fp) { printf("\tFAILED\n\r"); return -1; }
			fp1 = fopen("odbc.ini","rt");
			if(!fp1) { printf("\tFAILED\n\r"); return -1; }
			while(TRUE) {
				if(fread(&ch, sizeof(char), 1, fp)!=sizeof(char) || fread(&ch1, sizeof(char), 1, fp1)!=sizeof(char))
				{
					fread(&ch1, sizeof(char), 1, fp1);
					if(!(feof(fp) && feof(fp1))) { printf("\tFAILED\n\r"); return -1; }
					break;
				}
				if(ch != ch1) { printf("\tFAILED\n\r"); return -1; }
			}
			fclose(fp); fclose(fp1);

			printf("\tPASSED\n\r");
			break;
		case FALSE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDSN with (NULL, ODBC_CONFIGURE_DSN, argv[1], ATTRS2)\n\r");
	retcode = ConfigDSN(NULL, ODBC_CONFIG_DSN, argv[1], ATTRS2);
	switch(retcode) {
		case TRUE:
			fp = fopen("results/odbc.ini.3","rt");
			if(!fp) { printf("\tFAILED\n\r"); return -1; }
			fp1 = fopen("odbc.ini","rt");
			if(!fp1) { printf("\tFAILED\n\r"); return -1; }
			while(TRUE) {
				if(fread(&ch, sizeof(char), 1, fp)!=sizeof(char) || fread(&ch1, sizeof(char), 1, fp1)!=sizeof(char))
				{
					fread(&ch1, sizeof(char), 1, fp1);
					if(!(feof(fp) && feof(fp1))) { printf("\tFAILED\n\r"); return -1; }
					break;
				}
				if(ch != ch1) { printf("\tFAILED\n\r"); return -1; }
			}
			fclose(fp); fclose(fp1);

			printf("\tPASSED\n\r");
			break;
		case FALSE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDSN with (NULL, ODBC_REMOVE_DSN, argv[1], ATTRS2)\n\r");
	retcode = ConfigDSN(NULL, ODBC_REMOVE_DSN, argv[1], ATTRS2);
	switch(retcode) {
		case TRUE:
			fp = fopen("results/odbc.ini.2","rt");
			if(!fp) { printf("\tFAILED\n\r"); return -1; }
			fp1 = fopen("odbc.ini","rt");
			if(!fp1) { printf("\tFAILED\n\r"); return -1; }
			while(TRUE) {
				if(fread(&ch, sizeof(char), 1, fp)!=sizeof(char) || fread(&ch1, sizeof(char), 1, fp1)!=sizeof(char))
				{
					fread(&ch1, sizeof(char), 1, fp1);
					if(!(feof(fp) && feof(fp1))) { printf("\tFAILED\n\r"); return -1; }
					break;
				}
				if(ch != ch1) { printf("\tFAILED\n\r"); return -1; }
			}
			fclose(fp); fclose(fp1);

			printf("\tPASSED\n\r");
			break;
		case FALSE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDSN with (NULL, ODBC_REMOVE_DSN, argv[1], ATTRS1)\n\r");
	retcode = ConfigDSN(NULL, ODBC_REMOVE_DSN, argv[1], ATTRS1);
	switch(retcode) {
		case TRUE:
			fp = fopen("results/odbc.ini.4","rt");
			if(!fp) { printf("\tFAILED\n\r"); return -1; }
			fp1 = fopen("odbc.ini","rt");
			if(!fp1) { printf("\tFAILED\n\r"); return -1; }
			while(TRUE) {
				if(fread(&ch, sizeof(char), 1, fp)!=sizeof(char) || fread(&ch1, sizeof(char), 1, fp1)!=sizeof(char))
				{
					fread(&ch1, sizeof(char), 1, fp1);
					if(!(feof(fp) && feof(fp1))) { printf("\tFAILED\n\r"); return -1; }
					break;
				}
				if(ch != ch1) { printf("\tFAILED\n\r"); return -1; }
			}
			fclose(fp); fclose(fp1);

			printf("\tPASSED\n\r");
			break;
		case FALSE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	return 0;
}
