/*
 *  ConfigDriver.c
 *
 *  $Id: main.c,v 1.1 1999/09/30 15:00:41 source Exp $
 *
 *  Login test program
 *
 *  The iODBC driver manager.
 *  
 *  Copyright (C) 1999 by OpenLink Software <iodbc@openlinksw.com>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <config.h>
#include <iodbcinst.h>
#include <stdio.h>

#define DRIVER	"Virtuoso ODBC Driver\0Driver=/Net/Users/epoitier/lib/virtodbc.so.1\0Setup=/Net/Users/epoitier/lib/virtodbc.so.1\0\0"
#define DRIVER1 "Virtuoso ODBC Driver\0Driver=/Net/Users/epoitier/lib/virtodbc.so.2\0\0"
#define DRIVER2 "Virtuoso ODBC Driver\0Driver=/Net/Users/epoitier/lib/virtodbc.so.2\0CPTimeout=60\0\0"
#define DRIVER3 "Driver=/Net/Users/epoitier/lib/virtodbc.so.2\0CPTimeout=60\0\0"

int
main (int argc, char *argv[])
{
	BOOL retcode; DWORD errorcode;
	char errormsg[SQL_MAX_MESSAGE_LENGTH];
	char outpath[1024]={0};
	WORD len; int i;
	FILE *fp,*fp1;
	char ch,ch1;

	if(argc<2) return -1;

#ifndef _BE
	setenv("ODBCINI","./odbc.ini",TRUE);
	unlink("./odbc.ini");
	setenv("ODBCINSTINI","./odbcinst.ini",TRUE);
	unlink("./odbcinst.ini");
#endif

	printf("Test ConfigDriver with (NULL, ODBC_CONFIG_DRIVER_MAX+1, NULL, NULL, NULL, 0, NULL)\n\r");
	retcode = ConfigDriver(NULL, ODBC_CONFIG_DRIVER_MAX+1, NULL, NULL, NULL, 0, NULL);
	switch(retcode) {
		case FALSE:
			for(i=1 ; i<=8 ; i++) {
				switch( SQLInstallerError(i, &errorcode, errormsg, sizeof(errormsg), &len) ) {
					case SQL_NO_DATA:
						if(i==1) { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
						else break;
					case SQL_ERROR: printf("\tFAILED on SQLInstallerError\n\r"); return -1;
					case SQL_SUCCESS_WITH_INFO:
						if(i==1 && errorcode==ODBC_ERROR_INVALID_REQUEST_TYPE)
							{ printf("\tPASSED with a truncated string\n\r"); break; }
						else { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
					case SQL_SUCCESS:
						if(i==1 && errorcode==ODBC_ERROR_INVALID_REQUEST_TYPE)
							{ printf("\tPASSED\n\r"); break; }
						else { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
					default: printf("\tFAILED on SQLInstallerError\n\r"); return -1;
				};
			}
			break;
		case TRUE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDriver with (NULL, ODBC_INSTALL_DRIVER, NULL, NULL, NULL, 0, NULL)\n\r");
	retcode = ConfigDriver(NULL, ODBC_INSTALL_DRIVER, NULL, NULL, NULL, 0, NULL);
	switch(retcode) {
		case FALSE:
			for(i=2 ; i<=8 ; i++) {
				switch( SQLInstallerError(i, &errorcode, errormsg, sizeof(errormsg), &len) ) {
					case SQL_NO_DATA:
						if(i==2) { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
						else break;
					case SQL_ERROR: printf("\tFAILED on SQLInstallerError\n\r"); return -1;
					case SQL_SUCCESS_WITH_INFO:
						if(i==2 && errorcode==ODBC_ERROR_INVALID_NAME)
							{ printf("\tPASSED with a truncated string\n\r"); break; }
						else { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
					case SQL_SUCCESS:
						if(i==2 && errorcode==ODBC_ERROR_INVALID_NAME)
							{ printf("\tPASSED\n\r"); break; }
						else { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
					default: printf("\tFAILED on SQLInstallerError\n\r"); return -1;
				};
			}
			break;
		case TRUE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDriver with (NULL, ODBC_INSTALL_DRIVER, "", NULL, NULL, 0, NULL)\n\r");
	retcode = ConfigDriver(NULL, ODBC_INSTALL_DRIVER, "", NULL, NULL, 0, NULL);
	switch(retcode) {
		case FALSE:
			for(i=3 ; i<=8 ; i++) {
				switch( SQLInstallerError(i, &errorcode, errormsg, sizeof(errormsg), &len) ) {
					case SQL_NO_DATA:
						if(i==3) { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
						else break;
					case SQL_ERROR: printf("\tFAILED on SQLInstallerError\n\r"); return -1;
					case SQL_SUCCESS_WITH_INFO:
						if(i==3 && errorcode==ODBC_ERROR_INVALID_NAME)
							{ printf("\tPASSED with a truncated string\n\r"); break; }
						else { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
					case SQL_SUCCESS:
						if(i==3 && errorcode==ODBC_ERROR_INVALID_NAME)
							{ printf("\tPASSED\n\r"); break; }
						else { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
					default: printf("\tFAILED on SQLInstallerError\n\r"); return -1;
				};
			}
			break;
		case TRUE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDriver with (NULL, ODBC_INSTALL_DRIVER, argv[1], NULL, NULL, 0, NULL)\n\r");
	retcode = ConfigDriver(NULL, ODBC_INSTALL_DRIVER, argv[1], NULL, NULL, 0, NULL);
	switch(retcode) {
		case FALSE:
			for(i=1 ; i<=8 ; i++) {
				switch( SQLInstallerError(i, &errorcode, errormsg, sizeof(errormsg), &len) ) {
					case SQL_NO_DATA:
						if(i==1) { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
						else break;
					case SQL_ERROR: printf("\tFAILED on SQLInstallerError\n\r"); return -1;
					case SQL_SUCCESS_WITH_INFO:
						if(i==1 && errorcode==ODBC_ERROR_INVALID_PARAM_SEQUENCE)
							{ printf("\tPASSED with a truncated string\n\r"); break; }
						else { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
					case SQL_SUCCESS:
						if(i==1 && errorcode==ODBC_ERROR_INVALID_PARAM_SEQUENCE)
							{ printf("\tPASSED\n\r"); break; }
						else 
							if(i==2 && errorcode==ODBC_ERROR_DRIVER_SPECIFIC)
								{ printf("\tPASSED\n\r"); break; }
							else { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
					default: printf("\tFAILED on SQLInstallerError\n\r"); return -1;
				};
			}
			break;
		case TRUE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDriver with (NULL, ODBC_INSTALL_DRIVER, argv[1], DRIVER2, NULL, 0, NULL)\n\r");
	retcode = ConfigDriver(NULL, ODBC_INSTALL_DRIVER, argv[1], DRIVER2, NULL, 0, NULL);
	switch(retcode) {
		case TRUE:
			fp = fopen("results/odbcinst.ini.4","rt");
			if(!fp) { printf("\tFAILED\n\r"); return -1; }
			fp1 = fopen("odbcinst.ini","rt");
			if(!fp1) { printf("\tFAILED\n\r"); return -1; }
			while(TRUE) {
				if(fread(&ch, sizeof(char), 1, fp)!=sizeof(char) || fread(&ch1, sizeof(char), 1, fp1)!=sizeof(char))
				{
					fread(&ch1, sizeof(char), 1, fp1);
					if(!(feof(fp) && feof(fp1))) { printf("\tFAILED\n\r"); return -1; }
					break;
				}
				if(ch != ch1) { printf("\tFAILED\n\r"); return -1; }
			}
			fclose(fp); fclose(fp1);

			printf("\tPASSED\n\r");
			break;
		case FALSE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDriver with (NULL, ODBC_INSTALL_DRIVER, argv[1], DRIVER, NULL, 0, NULL)\n\r");
	retcode = ConfigDriver(NULL, ODBC_INSTALL_DRIVER, argv[1], DRIVER, NULL, 0, NULL);
	switch(retcode) {
		case TRUE:
			fp = fopen("results/odbcinst.ini.1","rt");
			if(!fp) { printf("\tFAILED\n\r"); return -1; }
			fp1 = fopen("odbcinst.ini","rt");
			if(!fp1) { printf("\tFAILED\n\r"); return -1; }
			while(TRUE) {
				if(fread(&ch, sizeof(char), 1, fp)!=sizeof(char) || fread(&ch1, sizeof(char), 1, fp1)!=sizeof(char))
				{
					fread(&ch1, sizeof(char), 1, fp1);
					if(!(feof(fp) && feof(fp1))) { printf("\tFAILED\n\r"); return -1; }
					break;
				}
				if(ch != ch1) { printf("\tFAILED\n\r"); return -1; }
			}
			fclose(fp); fclose(fp1);

			printf("\tPASSED\n\r");
			break;
		case FALSE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDriver with (NULL, ODBC_INSTALL_DRIVER, argv[1], DRIVER1, NULL, 0, NULL)\n\r");
	retcode = ConfigDriver(NULL, ODBC_INSTALL_DRIVER, argv[1], DRIVER1, NULL, 0, NULL);
	switch(retcode) {
		case TRUE:
			fp = fopen("results/odbcinst.ini.2","rt");
			if(!fp) { printf("\tFAILED\n\r"); return -1; }
			fp1 = fopen("odbcinst.ini","rt");
			if(!fp1) { printf("\tFAILED\n\r"); return -1; }
			while(TRUE) {
				if(fread(&ch, sizeof(char), 1, fp)!=sizeof(char) || fread(&ch1, sizeof(char), 1, fp1)!=sizeof(char))
				{
					fread(&ch1, sizeof(char), 1, fp1);
					if(!(feof(fp) && feof(fp1))) { printf("\tFAILED\n\r"); return -1; }
					break;
				}
				if(ch != ch1) { printf("\tFAILED\n\r"); return -1; }
			}
			fclose(fp); fclose(fp1);

			printf("\tPASSED\n\r");
			break;
		case FALSE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDriver with (NULL, ODBC_INSTALL_DRIVER, argv[1], DRIVER1, NULL, 0, NULL)\n\r");
	retcode = ConfigDriver(NULL, ODBC_INSTALL_DRIVER, argv[1], DRIVER1, NULL, 0, NULL);
	switch(retcode) {
		case TRUE:
			fp = fopen("results/odbcinst.ini.2","rt");
			if(!fp) { printf("\tFAILED\n\r"); return -1; }
			fp1 = fopen("odbcinst.ini","rt");
			if(!fp1) { printf("\tFAILED\n\r"); return -1; }
			while(TRUE) {
				if(fread(&ch, sizeof(char), 1, fp)!=sizeof(char) || fread(&ch1, sizeof(char), 1, fp1)!=sizeof(char))
				{
					fread(&ch1, sizeof(char), 1, fp1);
					if(!(feof(fp) && feof(fp1))) { printf("\tFAILED\n\r"); return -1; }
					break;
				}
				if(ch != ch1) { printf("\tFAILED\n\r"); return -1; }
			}
			fclose(fp); fclose(fp1);

			printf("\tPASSED\n\r");
			break;
		case FALSE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDriver with (NULL, ODBC_CONFIG_DRIVER, argv[1], NULL, NULL, 0, NULL)\n\r");
	retcode = ConfigDriver(NULL, ODBC_CONFIG_DRIVER, argv[1], NULL, NULL, 0, NULL);
	switch(retcode) {
		case FALSE:
			for(i=1 ; i<=8 ; i++) {
				switch( SQLInstallerError(i, &errorcode, errormsg, sizeof(errormsg), &len) ) {
					case SQL_NO_DATA:
						if(i==1) { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
						else break;
					case SQL_ERROR: printf("\tFAILED on SQLInstallerError\n\r"); return -1;
					case SQL_SUCCESS_WITH_INFO:
						if(i==1 && errorcode==ODBC_ERROR_DRIVER_SPECIFIC)
							{ printf("\tPASSED with a truncated string\n\r"); break; }
						else { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
					case SQL_SUCCESS:
						if(i==1 && errorcode==ODBC_ERROR_DRIVER_SPECIFIC)
							{ printf("\tPASSED\n\r"); break; }
						else { printf("\tFAILED on SQLInstallerError\n\r"); return -1; }
					default: printf("\tFAILED on SQLInstallerError\n\r"); return -1;
				};
			}
			break;
		case TRUE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDriver with (NULL, ODBC_CONFIG_DRIVER, argv[1], DRIVER3, NULL, 0, NULL)\n\r");
	retcode = ConfigDriver(NULL, ODBC_CONFIG_DRIVER, argv[1], DRIVER3, NULL, 0, NULL);
	switch(retcode) {
		case TRUE:
			fp = fopen("results/odbcinst.ini.5","rt");
			if(!fp) { printf("\tFAILED\n\r"); return -1; }
			fp1 = fopen("odbcinst.ini","rt");
			if(!fp1) { printf("\tFAILED\n\r"); return -1; }
			while(TRUE) {
				if(fread(&ch, sizeof(char), 1, fp)!=sizeof(char) || fread(&ch1, sizeof(char), 1, fp1)!=sizeof(char))
				{
					fread(&ch1, sizeof(char), 1, fp1);
					if(!(feof(fp) && feof(fp1))) { printf("\tFAILED\n\r"); return -1; }
					break;
				}
				if(ch != ch1) { printf("\tFAILED\n\r"); return -1; }
			}
			fclose(fp); fclose(fp1);

			printf("\tPASSED\n\r");
			break;
		case FALSE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	printf("Test ConfigDriver with (NULL, ODBC_REMOVE_DRIVER, argv[1], NULL, NULL, 0, NULL)\n\r");
	retcode = ConfigDriver(NULL, ODBC_REMOVE_DRIVER, argv[1], NULL, NULL, 0, NULL);
	switch(retcode) {
		case TRUE:
			fp = fopen("results/odbcinst.ini.3","rt");
			if(!fp) { printf("\tFAILED\n\r"); return -1; }
			fp1 = fopen("odbcinst.ini","rt");
			if(!fp1) { printf("\tFAILED\n\r"); return -1; }
			while(TRUE) {
				if(fread(&ch, sizeof(char), 1, fp)!=sizeof(char) || fread(&ch1, sizeof(char), 1, fp1)!=sizeof(char))
				{
					fread(&ch1, sizeof(char), 1, fp1);
					if(!(feof(fp) && feof(fp1))) { printf("\tFAILED\n\r"); return -1; }
					break;
				}
				if(ch != ch1) { printf("\tFAILED\n\r"); return -1; }
			}
			fclose(fp); fclose(fp1);

			printf("\tPASSED\n\r");
			break;
		case FALSE:
		default: printf("\tFAILED\n\r"); return -1;
	};

	return 0;
}
